From bde7c3cc98f52f3cba0ae3c2f53220fd9c570c5b Mon Sep 17 00:00:00 2001
From: Stephen Gallagher <sgallagh@redhat.com>
Date: Jan 18 2018 16:36:31 +0000
Subject: [PATCH 12/48] Add support for securitylevels


---

diff --git a/modulemd/__init__.py b/modulemd/__init__.py
index 757fbd2..3f3ee5b 100644
--- a/modulemd/__init__.py
+++ b/modulemd/__init__.py
@@ -142,7 +142,7 @@ class ModuleMetadata(object):
         # Don't pre-set EOL, since we don't have a valid value yet
         # The Modulemd.Module() default initializes it to an appropriate invalid
         # date.
-        # self.module.set_eol()
+        self.module.set_servicelevels({})
         self.module.set_module_licenses(Modulemd.SimpleSet())
         self.module.set_content_licenses(Modulemd.SimpleSet())
         self.module.set_buildrequires({})
@@ -378,6 +378,16 @@ class ModuleMetadata(object):
         self.module.set_eol(d)
 
     @property
+    def servicelevels(self):
+        """A dictionary of service levels applying to this module"""
+        return self.module.get_servicelevels()
+
+    @servicelevels.setter
+    def servicelevels(self, d):
+        if not isinstance(d, dict):
+            self.module.set_servicelevels(d)
+
+    @property
     def module_licenses(self):
         """A set of strings, a property, representing the license terms
         of the module itself."""
diff --git a/modulemd/tests/test_io.py b/modulemd/tests/test_io.py
index c420eb9..8912912 100644
--- a/modulemd/tests/test_io.py
+++ b/modulemd/tests/test_io.py
@@ -53,6 +53,16 @@ class TestIO(unittest.TestCase):
         self.assertEqual(self.mmd.summary, "An example module")
         self.assertEqual(self.mmd.description, "A module for the demonstration of the metadata format. Also, the obligatory lorem ipsum dolor sit amet goes right here.")
         self.assertEqual(self.mmd.eol, datetime.date(2077, 10, 23))
+        securitylevel = self.mmd.servicelevels['security']
+        securityeol = datetime.date(securitylevel.get_eol().get_year(),
+                                    securitylevel.get_eol().get_month(),
+                                    securitylevel.get_eol().get_day())
+        self.assertEqual(securityeol, datetime.date(2019, 3, 30))
+        featurelevel = self.mmd.servicelevels['features']
+        featureeol = datetime.date(featurelevel.get_eol().get_year(),
+                                   featurelevel.get_eol().get_month(),
+                                   featurelevel.get_eol().get_day())
+        self.assertEqual(featureeol, datetime.date(2018, 12, 31))
         self.assertSetEqual(self.mmd.module_licenses, set(["MIT"]))
         self.assertSetEqual(self.mmd.content_licenses,
                 set(["Beerware", "GPLv2+", "zlib"]))
diff --git a/modulemd/tests/test_validation.py b/modulemd/tests/test_validation.py
index 19abc8f..563dd2a 100644
--- a/modulemd/tests/test_validation.py
+++ b/modulemd/tests/test_validation.py
@@ -77,6 +77,9 @@ class TestValidation(unittest.TestCase):
     def test_eol_type(self):
         self.assertRaises(TypeError, setattr, self.mmd, "eol", 0)
 
+    def test_servicelevels_type(self):
+        self.assertRaises(TypeError, setattr, self.mmd, "servicelevels", 0)
+
     def test_module_license_type(self):
         self.assertRaises(TypeError, setattr, self.mmd, "module_licenses", 0)
 
